;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Counter8_CLK_UART.inc
;;   Version: 2.5, Updated on 2008/6/23 at 12:23:15
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the Counter8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for Counter8_CLK_UART API's.
;--------------------------------------------------

Counter8_CLK_UART_CONTROL_REG_START_BIT:   equ 0x01    ; Control register start bit
Counter8_CLK_UART_INT_REG:                 equ 0x0df
Counter8_CLK_UART_INT_MASK:                equ 0x20


;--------------------------------------------------
; Constants for Counter8_CLK_UART user defined values
;--------------------------------------------------

Counter8_CLK_UART_PERIOD:                  equ 0x52
Counter8_CLK_UART_COMPARE_VALUE:           equ 0x29


;--------------------------------------------------
; Register Address Constants for Counter8_CLK_UART
;--------------------------------------------------

Counter8_CLK_UART_COUNTER_REG:         equ 0x54   ; DR0 Counter register
Counter8_CLK_UART_PERIOD_REG:          equ 0x55   ; DR1 Period register
Counter8_CLK_UART_COMPARE_REG:         equ 0x56   ; DR2 CompareValue register
Counter8_CLK_UART_CONTROL_REG:         equ 0x57   ; Control register
Counter8_CLK_UART_FUNC_REG:            equ 0x54   ; Function register
Counter8_CLK_UART_INPUT_REG:           equ 0x55   ; Input register
Counter8_CLK_UART_OUTPUT_REG:          equ 0x56   ; Output register


;--------------------------------------------------
; Counter8_CLK_UART Macro 'Functions'
;--------------------------------------------------

   macro Counter8_CLK_UART_Start_M
   or    reg[Counter8_CLK_UART_CONTROL_REG],  Counter8_CLK_UART_CONTROL_REG_START_BIT
   endm

   macro Counter8_CLK_UART_Stop_M
   and   reg[Counter8_CLK_UART_CONTROL_REG], ~Counter8_CLK_UART_CONTROL_REG_START_BIT
   endm

   macro Counter8_CLK_UART_EnableInt_M
   M8C_EnableIntMask Counter8_CLK_UART_INT_REG, Counter8_CLK_UART_INT_MASK
   endm

   macro Counter8_CLK_UART_DisableInt_M
   M8C_DisableIntMask Counter8_CLK_UART_INT_REG, Counter8_CLK_UART_INT_MASK
   endm


; end of file Counter8_CLK_UART.inc
