;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWM16_BP23.inc
;;   Version: 2.5, Updated on 2008/6/23 at 12:25:28
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the PWM16 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for PWM16_BP23 API's.
;--------------------------------------------------

PWM16_BP23_CONTROL_REG_START_BIT:          equ 0x01    ; Control register start bit
PWM16_BP23_INT_REG:                        equ 0x0e1
PWM16_BP23_INT_MASK:                       equ 0x80


;--------------------------------------------------
; Constants for PWM16_BP23 user defined values
;--------------------------------------------------

PWM16_BP23_PERIOD:                         equ 0x48b
PWM16_BP23_PULSE_WIDTH:                    equ 0x246


;--------------------------------------------------
; Register Address Constants for PWM16_BP23
;--------------------------------------------------

PWM16_BP23_COUNTER_LSB_REG:            equ 0x38   ; DR0 Count register
PWM16_BP23_COUNTER_MSB_REG:            equ 0x3c
PWM16_BP23_PERIOD_LSB_REG:             equ 0x39   ; DR1 Period register
PWM16_BP23_PERIOD_MSB_REG:             equ 0x3d
PWM16_BP23_COMPARE_LSB_REG:            equ 0x3a   ; DR2 Compare register
PWM16_BP23_COMPARE_MSB_REG:            equ 0x3e
PWM16_BP23_CONTROL_LSB_REG:            equ 0x3b   ; Control register
PWM16_BP23_CONTROL_MSB_REG:            equ 0x3f
PWM16_BP23_FUNC_LSB_REG:               equ 0x38   ; Function register
PWM16_BP23_FUNC_MSB_REG:               equ 0x3c
PWM16_BP23_INPUT_LSB_REG:              equ 0x39   ; Input register
PWM16_BP23_INPUT_MSB_REG:              equ 0x3d
PWM16_BP23_OUTPUT_LSB_REG:             equ 0x3a   ; Output register
PWM16_BP23_OUTPUT_MSB_REG:             equ 0x3e


;--------------------------------------------------
; PWM16_BP23 Macro 'Functions'
;--------------------------------------------------

   macro PWM16_BP23_Start_M
   or    reg[PWM16_BP23_CONTROL_LSB_REG],  PWM16_BP23_CONTROL_REG_START_BIT
   endm

   macro PWM16_BP23_Stop_M
   and   reg[PWM16_BP23_CONTROL_LSB_REG], ~PWM16_BP23_CONTROL_REG_START_BIT
   endm

   macro PWM16_BP23_EnableInt_M
   M8C_EnableIntMask PWM16_BP23_INT_REG, PWM16_BP23_INT_MASK
   endm

   macro PWM16_BP23_DisableInt_M
   M8C_DisableIntMask PWM16_BP23_INT_REG, PWM16_BP23_INT_MASK
   endm


; end of file PWM16_BP23.inc

