//*********************************************************
//		printf to
//*********************************************************

#include <m8c.h>		// part specific constants and macros
#include "PSoCAPI.h"	// PSoC API definitions for all User Modules
#include <stdlib.h>

//*******************************
//		萔 `
//*******************************
#define	PD_LCD		0		// \uC0:LCD , 1;SIO(UART)
#define	PD_SIO		1		// \uC0:LCD , 1;SIO(UART)

#define 	EOS 	0x00
#define		CR		0x0D
#define		LF		0x0A

//*********************
//  f[^p `
//*********************
union	DATAS {
	float		fdat;
	unsigned long	dword;
	unsigned int	word[2];
	unsigned char	byte[4];
};

//*******************************
//	vg^Cv錾
//*******************************
// #define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
// #include	"printf.h"		// printf to
void print_str(unsigned char *);		//  o
void print_val(unsigned int, unsigned int, unsigned int, union DATAS);	// t l o
void fmtout(const unsigned char *, unsigned int *);		// to fmtout

//*******************************
//		O[oϐ
//*******************************
unsigned int param[4];
static union DATAS udat;
static unsigned char tbuf[20];
unsigned char prt_device;		// \uC0:LCD , 1;SIO(UART)
unsigned char lcd_xpos;			// LCD \ʒu 
unsigned char lcd_ypos;			// LCD \ʒu s

//=======================================================================

//*******************************
//   \u ؑւݒ
//*******************************
void set_prtdev_lcd(void) {		// \uLCDɂ
	prt_device = PD_LCD ;
}
void set_prtdev_sio(void) {		// \uSIO(UART)ɂ
	prt_device = PD_SIO ;
}


// *****************************************
// 1 Print (called by printf)
// *****************************************
void print_chr(unsigned char c) {
	if (prt_device == PD_SIO) { 	// SIOo
		UART_1_PutChar(c);
	} else {						// LCDo
		LCD_1_Position(lcd_ypos, lcd_xpos);		// \ʒuZbg
		if (c == '\r') {	// 擪ʒuɖ߂iLbWE^[j
			lcd_xpos = 0;
			return;
		} // end if \r
		if (c == '\n') {	// 擪ʒuɖ߂CXɉsiCEtB[hj
			lcd_ypos++;
			lcd_xpos = 0;
		} else {			// o
			LCD_1_WriteData(c);
			lcd_xpos++;
		} // end if \n
	} // end if prt_device
}

//*********************
// ̕JEg
//*********************
unsigned int slen(unsigned char *str) {
	unsigned int	len;
	for (len=0; *str; len++, str++) {
		;
	}
	return(len);
}

//*********************
//  o
//*********************
void print_str(unsigned char *c) {
	while(*c) {
		print_chr(*c++);
	}
}

//*********************
//  no
//*********************
void print_pads(int width, unsigned int padchar) {
	while(width-- > 0) {
		print_chr(padchar);
	}
}

//*********************
// t l o
//*********************
void print_val(unsigned int width, unsigned int padchar, unsigned int base, union DATAS data) {
	unsigned int	datwidth;
	unsigned char	*p;

	p = tbuf;
	if (data.word[1]) {				// 32rbgf[^
		for (datwidth = 0; data.dword > 0; datwidth++) {
			if ((*p = (unsigned char )((data.dword % base) + '0')) > '9') {
				*p += (unsigned char)('A' - '0' - 10);
			}
			p++;
			data.dword /= base;
		} // end for
	} else {							// 16rbgf[^
		for (datwidth = 0; data.word[0] > 0; datwidth++) {
			if ((*p = (unsigned char )((data.word[0] % base) + '0')) > '9') {
				*p += (unsigned char)('A' - '0' - 10);
			}
			p++;
			data.word[0] /= base;
		} // end for
	} // end if data.word[1]
	if (datwidth == 0) {
		*p++ = '0';
		datwidth = 1;
	}
	print_pads(width - datwidth, padchar);
	while (datwidth--) {
		print_chr(*--p);
	}
}

//*********************
// to fmtout
//*********************
void fmtout(const unsigned char *str, unsigned int *param) {
	unsigned char padchar;
	unsigned char *cp;
	unsigned int  width;
	int 		status;

	while (*str) {
		if (*str == LF) {
			print_chr(CR);
			print_chr(LF);
			str++;
			continue;
		}
		if (*str != '%') {
			print_chr(*str++);
			continue;
		}
		str++;
		padchar = *str;
		if (padchar == '0') {
			str++;
		} else {
			padchar = ' ';
		}
		for (width = 0; (*str >= '0' && *str <= '9'); width = width * 10 + (*str++ - '0')) {
			;
		}
		if (!width) {
			width++;
		}
		if ((*str == 'L') || (*str == 'l')) {
				str++;
				udat.word[1] = *param--;
		} else {
			udat.word[1] = 0;
		}
		switch (*str) {
			case 'b': 
			case 'B': 
				udat.word[0] = *param--;
				print_val(width,padchar,2,udat);
				break;
			case 'o': 
			case 'O': 
				udat.word[0] = *param--;
				print_val(width,padchar,8,udat);
				break;
			case 'u': 
			case 'U': 
				udat.word[0] = *param--;
				print_val(width,padchar,10,udat);
				break;
			case 'd': 
			case 'D': 
				udat.word[0] = *param--;
				print_val(width,padchar,10,udat);
				break;
			case 'x': 
			case 'X': 
				udat.word[0] = *param--;
				print_val(width,padchar,16,udat);
				break;
			case 'f': 
				if (width == 1) {
					width = 15;	// ftoa ̃obt@TCY
				}
				udat.word[1] = *param--;
				udat.word[0] = *param--;
				cp = ftoa(udat.fdat, &status);
				if (status != 0) {
					break;
				}
				while (*cp != EOS) {
					if (!width) break;
					print_chr(*cp++);
					width--;
				}
				while (width--) {
					print_chr(padchar);
				}
				break;
			case 'c': 
				print_pads(width-1,' ');
				print_chr(*param--);
				break;
			case 's': 
				width -= slen((unsigned char *)(*param));
				print_pads(width,' ');
				print_str((unsigned char *)(*param));
				param--;
				break;
			default: 
				print_chr('%');
				print_chr(*str);
				break;
		} // end switch
		str++;
	} // end while
}

//*********************
// to printf
//*********************
void printf( const unsigned char *str, unsigned int arg) {
	fmtout(str, &arg);
}

//*********************
//	s(CR,LF)
//*********************
void printCRLF(void) {
	print_chr(0x0D);		// 1 Print
	print_chr(0x0A);
}

//*********************
//	J}(" , ")
//*********************
void printComma(void) {
	print_chr(' '); 		// 1 Print
	print_chr(',');
	print_chr(' ');
}


//***************************
//  LCD \ʒuHOME
//***************************
void  lcd_home(void) { 
	extern unsigned char lcd_xpos;			// LCD \ʒu 
	extern unsigned char lcd_ypos;			// LCD \ʒu s

	lcd_ypos = 0;	
	lcd_xpos = 0;
	LCD_1_Position(lcd_ypos, lcd_xpos);		// \ʒuZbg
}
//********************************
//  LCD ʃNA & \ʒuHOME
//********************************
void  lcd_cls_home(void) { 
	LCD_1_Control(1); 
	LCD_1_Control(2); 
}

//***************************
//  LCD J[\\^
//***************************
void  lcd_csr_on(void) { 
	LCD_1_Control(15); 
}
void  lcd_csr_off(void) { 
	LCD_1_Control(12); 
}

